Pages/ArticleDetails.cshtml.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.EntityFrameworkCore;
using Project_PRN221_1.Models;

namespace Project_PRN221_1.Pages
{
    public class ArticleDetailsModel : PageModel
    {
        private readonly Project_PRN221_1Context _context;

        public Post postDetail;

        public User user;

        public List<Comment> comment;

        public List<Category> Categories { get; set; }
        [BindProperty]
        public string postCensorId { get; set; }


		public ArticleDetailsModel(Project_PRN221_1Context context)
        {
            _context = context;
        }
        public void OnGet(string id)
        {
            if (id == null)
            {
                RedirectToPage("Error");
            }
            else
            {
                Categories = _context.Categories.ToList();
                postDetail = _context.Posts.Find(int.Parse(id));
                user = _context.Users.FirstOrDefault(u => u.UserId == postDetail.UserId);
                comment = _context.Comments.Include(c => c.User).Where(c => c.PostId == int.Parse(id)).ToList();
            }
        }

        public IActionResult OnPost()
        {
			var postDetail = _context.Posts.FirstOrDefault(post => post.PostId == int.Parse(postCensorId));

			if (postDetail != null)
			{
				postDetail.IsCensor = 1;

				_context.Posts.Update(postDetail);
				_context.SaveChanges();
			}
			return RedirectToPage("/Index");
        }
    }
}

Pages/Error.cshtml.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using System.Diagnostics;

namespace Project_PRN221_1.Pages
{
    [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
    [IgnoreAntiforgeryToken]
    public class ErrorModel : PageModel
    {
        public string? RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);

        private readonly ILogger<ErrorModel> _logger;

        public ErrorModel(ILogger<ErrorModel> logger)
        {
            _logger = logger;
        }

        public void OnGet()
        {
            RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier;
        }
    }
}

Pages/Index.cshtml.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.EntityFrameworkCore;
using Project_PRN221_1.Models;

namespace Project_PRN221_1.Pages
{
    public class IndexModel : PageModel
    {
        private readonly Project_PRN221_1Context _context;

        public IndexModel(Project_PRN221_1Context context)
        {
            _context = context;
        }

        public List<Category> Categories { get; set; }

        public List<Post> PostList { get; set; }

        public Post post { get; set; }

        public string? roleId { get; set; }

        [BindProperty]
        public int postId { get; set; }

		[BindProperty(SupportsGet = true)]
		public string SearchTerm { get; set; }
		public void OnGet(string category)
        {
            Categories = _context.Categories.ToList();
            roleId = HttpContext.Session.GetString("Role");
            if (!string.IsNullOrEmpty(category))
            {
                var categoryId = _context.Categories.Where(c => c.CategoryName == category).Select(c => c.CategoryId).FirstOrDefault();
                if (categoryId != 0)
                {
                    PostList = _context.Posts.Where(post => post.CategoryId == categoryId).ToList();
                }
            }
            else
            {
                PostList = _context.Posts.OrderByDescending(p => p.PostDate).ToList();
            }
        }
        public IActionResult OnPost(string category)
        {
            Categories = _context.Categories.ToList();
            if (!string.IsNullOrEmpty(category))
            {
                var categoryId = _context.Categories.Where(c => c.CategoryName == category).Select(c => c.CategoryId).FirstOrDefault();
                if (categoryId != 0)
                {
					PostList = _context.Posts.Where(post => post.CategoryId == categoryId).ToList();
                }
            }
            else
            {
				PostList = _context.Posts.OrderByDescending(p => p.PostDate).ToList();
			}

            return Page();
        }

        public IActionResult OnPostSearch()
        {
			Categories = _context.Categories.ToList();
			PostList = _context.Posts
				.Where(post =>EF.Functions.Like(post.PostHeader, $"%{SearchTerm}%"))
				.OrderByDescending(p => p.PostDate)
				.ToList();
			return Page();
		}

        public IActionResult OnPostDecensor()
        {
			Categories = _context.Categories.ToList();
            if (postId != 0)
            {
                post = _context.Posts.FirstOrDefault(p => p.PostId == postId);
                if (post != null)
                {
                    post.IsCensor = 0;
                    _context.Posts.Update(post);
                    _context.SaveChanges();
                }
            }
			PostList = _context.Posts.OrderByDescending(p => p.PostDate).ToList();
			return Page();
        }

        public IActionResult OnPostDelete()
        {
			Categories = _context.Categories.ToList();
			if (postId != 0)
			{
				post = _context.Posts.FirstOrDefault(p => p.PostId == postId);
				if (post != null)
				{
					var postComments = _context.Comments.Where(c => c.PostId == postId).ToList();
					foreach (var comment in postComments)
					{
						_context.Comments.Remove(comment);
					}
					_context.Posts.Remove(post);
					_context.SaveChanges();
				}
			}
			PostList = _context.Posts.OrderByDescending(p => p.PostDate).ToList();
			return Page();
        }
    }
}

Pages/ArticleDetails.cshtml
@page
@model Project_PRN221_1.Pages.ArticleDetailsModel
@{
	var username = HttpContext.Session.GetString("Username");
	var nameDisp = HttpContext.Session.GetString("UserNameDisp");
	int userId = -1;
	if (HttpContext.Session.GetString("UserId") != null)
	{
		userId = int.Parse(HttpContext.Session.GetString("UserId"));
	}
}
<style>
	.image-container {
		display: flex;
		justify-content: center;
		align-items: center;
		height: 400px; 
	}

		.image-container img {
			max-width: 100%; 
			max-height: 100%;
		}

	span {
		font-size: 0.8em;
		color: rgba(0, 0, 0, 0.5); 
	}
</style>
<div class="container">
	<!-- Tiêu đề bài viết -->
	<h1 class="mt-5 mb-4">@Model.postDetail.PostHeader</h1>

	<!-- Thông tin tác giả và ngày đăng -->
	<p class="text-muted">Author: <strong>@Model.user.Username</strong> | Date: <strong>@Model.postDetail.PostDate</strong></p>

	<!-- Nội dung bài viết -->
	<div class="mb-4">
		@for (int i = 1; i <= 5; i++)
		{
			var postGraph = "PostGraph" + i;
			var imagePath = "Image" + i + "Path";

			if (Model.postDetail.GetType().GetProperty(postGraph).GetValue(Model.postDetail) != null)
			{
				<p>
					@Model.postDetail.GetType().GetProperty(postGraph).GetValue(Model.postDetail)
				</p>

				<!-- Thẻ cho hình ảnh trong bài viết -->
				@if (Model.postDetail.GetType().GetProperty(imagePath).GetValue(Model.postDetail) != null)
				{
					var imageValue = Model.postDetail.GetType().GetProperty(imagePath).GetValue(Model.postDetail).ToString();
					<div class="image-container">
						<img src="@Url.Content(imageValue)" class="img-fluid mb-4" alt="Hình minh họa">
					</div>
				}
			}
		}
	</div>
	@if (Model.postDetail.IsCensor == 0)
	{
		<form method="post">
			<button type="submit" class="btn btn-primary" >Allow</button>
			<input type="hidden" name="postCensorId" value="@Model.postDetail.PostId"/>
		</form>
	}
	else
	{
		<div>
			<h3>Comments</h3>
			<ul class="list-unstyled">
				<li class="media mb-3">
					@foreach (var c in Model.comment)
					{
						<div class="media-body">
							<h5 class="mt-0 mb-1">@c.User.Name</h5>
							<span>@c.CommentDate</span>
							<br>
							@c.CommentContent
						</div>
					}
				</li>
			</ul>
		</div>
		<hr />
		@if (username != null)
		{
			<!-- Phần bình luận -->
			<div class="mb-4">
				<!-- Form nhập bình luận -->
				<form asp-page="/commentposts/commentpost" method="post">
					<div class="mb-3">
						<label for="inputName" class="form-label">Name</label>
						@if (nameDisp != null)
						{
							<input type="text" class="form-control" id="inputName" value="@nameDisp" readonly>
						}
					</div>
					<div class="mb-3">
						<label for="inputComment" class="form-label">Comment</label>
						<textarea class="form-control" id="inputComment" name="CommentContent" rows="3" placeholder="Input your comment"></textarea>
					</div>
					<input type="hidden" name="UserId" value="@userId" />
					<input type="hidden" name="PostId" value="@Model.postDetail.PostId" />
					<button type="submit" class="btn btn-primary">Save</button>
				</form>
			</div>
		}
	}
</div>

Pages/Index.cshtml
@page
@model IndexModel
@{
	var username = HttpContext.Session.GetString("Username");
	var nameDisp = HttpContext.Session.GetString("UserNameDisp");
	var role = HttpContext.Session.GetString("Role");
	int userId = -1;
	if (HttpContext.Session.GetString("UserId") != null)
	{
		userId = int.Parse(HttpContext.Session.GetString("UserId"));
	}
}
<nav style="float: right">
	<div class="container">
		@if (username != null)
		{
			<span class="navbar-text mr-3">Welcome, @nameDisp</span>
			<form class="form-inline" asp-page="/login/logout" method="get">
				<button type="submit" class="btn btn-link nav-link">Logout</button>
			</form>
			<div>
				<form class="form-inline" asp-page="/newpost/newpost" method="get">
					<button type="submit" class="btn btn-link nav-link">Create new post</button>
				</form>
			</div>
			if (role == "2")
			{
				<div>
					<form class="form-inline" asp-page="/admin/UserManage" method="get">
						<button type="submit" class="btn btn-link nav-link">User Manage</button>
					</form>
				</div>
			}
			if (role == "3")
			{
				<div>
					<form class="form-inline" asp-page="/admin/censor" method="get">
						<button type="submit" class="btn btn-link nav-link">Post Moderation</button>
					</form>
				</div>
			}
			<div>
				<form class="form-inline" asp-page="/usermanage/profile" method="get">
					<button type="submit" class="btn btn-link nav-link">Profile</button>
				</form>
			</div>

		}
		else
		{
			<a class="btn btn-primary" href="/Login/regist">Register</a>
			<a class="btn btn-primary" href="/Login/login">Login</a>
		}
	</div>
</nav>
<!-- Main Content -->
<div class="container mt-4">
	<!-- Search form -->
	<div class="row">
		<div class="col-md-6 offset-md-3">
			<form asp-page-handler="Search" method="post" class="form-inline mb-4">
				<div class="input-group w-100">
					<input type="text" class="form-control" asp-for="SearchTerm" placeholder="Search by title" aria-label="Search" aria-describedby="button-addon2">
					<button class="btn btn-primary" type="submit" id="searchButton">Search</button>
				</div>
			</form>
		</div>
	</div>
	<div class="row">
		<!-- Lastest Articles -->
		<ul class="list-group" style="border: none">
			@if (Model.PostList.Count() == 0 || Model.PostList.All(post => post.IsCensor == 0))
			{
				<h4>No posts to show</h4>
			}
			else
			{
				@for (int i = 0; i < Model.PostList.Count(); i++)
				{
					@if (Model.PostList[i].IsCensor == 1)
					{
						<li class="list-group-item" style="border: none">
							<div class="row" style="padding-bottom: 10px; border-bottom: 1px solid;">
								<div class="col-md-3">
									<h5><a href="ArticleDetails?Id=@Model.PostList[i].PostId">@Model.PostList[i].PostHeader</a></h5>
									<p>@Model.PostList[i].PostGraph1</p>
								</div>
								<div class="col-md-7">
									<img class="latestpost-image" src="@Url.Content(Model.PostList[i].Image1Path)" alt="Popular Post Image" style="width: 500px; height: 350px;">
								</div>
								<div class="col-md-2">
									@if (Model.roleId == "3")
									{
										<form method="post" asp-page-handler="Decensor">
											<input type="hidden" name="postId" value="@Model.PostList[i].PostId" />
											<button type="submit" class="btn btn-warning">Decensor</button>
										</form>
										<form method="post" asp-page-handler="Delete">
											<input type="hidden" name="postId" value="@Model.PostList[i].PostId" />
											<button type="submit" class="btn btn-danger">Delete</button>
										</form>
									}
								</div>
							</div>
						</li>
					}
				}
			}
		</ul>
	</div>
</div>